//###################################################################################
// File: dosdelete.c
//
// Mehrere Dateien auf einen frisch formatierten CF schreiben bis er voll ist.
// Es werden immer nur 250kB pro Datei geschrieben. Die FAT wird dabei fragmentiert.
// Dann "0.txt" lschen ! Nachsehen was Scandisk dazu sagt ;)
//
//#########################################################################
// Last change: 26.09.2006
//#########################################################################
// hk@holger-klabunde.de
// http://www.holger-klabunde.de/index.html
//#########################################################################
// Processor: ATMega32
//#########################################################################
// Compiler: AVR-GCC 3.4.3
//#########################################################################
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>

#include "mydefs.h"
#include "protos.h"
#include "../lcd.h"
#include "../dos.h"
#include "../printf.h"
#include "../serial.h"

//"volatile" fr alle Variablen die in Interrupt's gendert werden
unsigned int volatile countclock;

//###################################################################################
// timeout not used !
// interrupt every 47.4ms  @ 11.0592MHz
// interrupt every 32.77ms @ 16.0000MHz
SIGNAL(SIG_OVERFLOW1)        // signal handler for timer1 overflow interrupt
//###################################################################################
{
 countclock++;
}

//###################################################################################
unsigned char WriteTestFile(char *name)
//###################################################################################
{
 unsigned char result;
 unsigned long bytecount;

 char f_id;

 bytecount=0;
 result=F_OK;
 
 f_id=Fopen(name,F_WRITE);
 if(f_id>=0)
  {
   do
    {
     if(Fwrite("Hello World. Hello World. Hello World. Hello World.\n",52,f_id)!=52) result=F_ERROR;
     if(result!=F_ERROR) bytecount+=(unsigned long)52;

    }while(bytecount < (unsigned long)250000 && result==F_OK );

   Fclose(f_id);
  }

 return result;
}

//###################################################################################
/* Hauptprogramm */
int main(void)
//###################################################################################
{
 unsigned char loop;
 
 DDRA=0; 	//Alles Eingnge
 PORTA=0xFF; 	//Eingnge mit Pullups setzen

 SFIOR&=!(1<<PUD); 	//Pullups Enable
// SFIOR=0; 	//Pullups Enable

#ifdef MMC_CARD_SPI
 MMC_IO_Init();
#endif

 ser_init();
 LCDInit();

//Timer1
 TCCR1A=0; 
 TCCR1B=0x02;        //Timer1 Start Takt = F/8 => 47.4ms at 11.059MHz
 TIMSK=(1<<TOIE1);   // enable timer1 int

 sei();              //enable interrupts

 LCDCls();
 puts("FAT DOS-Delete-Test");
 LCDPos(2,1);
 puts("by Holgi");
 Delay1ms(1000);
 LCDCls();

 if(GetDriveInformation()!=F_OK) // get drive parameters
  {
   LCDCls();
   puts("Flash meldet sich nicht !");
   while(1);
  }
  
 RED_ON();
 GREEN_OFF();

//Ein paar Verzeichnisse/Unterverzeichnisse erzeugen
 Mkdir("dir1");
 Chdir("dir1");
 Mkdir("dir3"); // dir1/dir3
 Chdir("/");    //Back to the roots
 Mkdir("dir2");
 Chdir("dir2");
 Mkdir("dir4"); // dir2/dir4
 Chdir("/");    //Back to the roots

// Schreibe mehrere Dateien und fragmentiere die FAT dabei
 countclock=0;
 loop=0;
 for(;;)
  {
   LCDPos(1,1); LCDWrite("0.txt");
   if(WriteTestFile("0.txt")!=F_OK) break;
   Chdir("dir1");
   LCDPos(1,1); LCDWrite("1.txt");
   if(WriteTestFile("1.txt")!=F_OK) break;
   Chdir("dir3");
   LCDPos(1,1); LCDWrite("3.txt");
   if(WriteTestFile("3.txt")!=F_OK) break;
   Chdir("..");
   LCDPos(1,1); LCDWrite("1.txt");
   if(WriteTestFile("1.txt")!=F_OK) break;
   Chdir("..");
   LCDPos(1,1); LCDWrite("0.txt");
   if(WriteTestFile("0.txt")!=F_OK) break;
   Chdir("dir2");
   LCDPos(1,1); LCDWrite("2.txt");
   if(WriteTestFile("2.txt")!=F_OK) break;
   Chdir("dir4");
   LCDPos(1,1); LCDWrite("4.txt");
   if(WriteTestFile("4.txt")!=F_OK) break;
   Chdir("..");
   LCDPos(1,1); LCDWrite("2.txt");
   if(WriteTestFile("2.txt")!=F_OK) break;
   Chdir("..");
   LCDPos(1,1); LCDWrite("0.txt");
   if(WriteTestFile("0.txt")!=F_OK) break;

   loop++;
   LCDPos(2,1);
   printf("%d\n",(int)loop);
  }

 Chdir("/");
 
// Und nun viel Glck !!
 LCDCls();
 puts("Deleting 0.txt");
 Remove("0.txt");
  
 GREEN_ON();
 RED_OFF();
 cli(); // Disable interrupts
 LCDPos(2,1);
 printf("%d\n",countclock);
 
 for(;;) // loop forever
  {
  }
}

