//#########################################################################
// File: killcard.c
//
// Lscht die gesamte CF/MMC/SD
// Danach ist nichts mehr drauf. Alles weg. Keine Partitionstabelle
// kein Bootsektor, kein FAT. Alles Null.
//
// Sie muss formatiert werden.
//
// Ausgabe des aktuellen Sektors auf RS232
// 19200 Baud, 8 Bit, 1 Stopbit, kein Parity, kein Handshake
//
// This program erases all data on the card. All sectors will be filled
// with zeroes. Partitiontable, bootsector and fat all will be erased.
// You have to format the card after running this program !
//
//#########################################################################
// Last change: 21.02.2007
//#########################################################################
// hk@holger-klabunde.de
// http://www.holger-klabunde.de/index.html
//#########################################################################
// Compiler: AVR-GCC 3.4.5
//#########################################################################
#include <avr/io.h>
#include <avr/interrupt.h>

#include <stdarg.h>
#include <string.h>
#include <stdlib.h>

#include "mydefs.h"
#include "protos.h"
#include "../lcd.h"
#include "../dos.h"
#include "../serial.h"
#include "../printf.h"

//"volatile" fr alle Variablen die in Interrupt's gendert werden
unsigned int volatile countclock;

//###################################################################################
/* Hauptprogramm */
int main(void)
//###################################################################################
{
 DDRC=0xFF;  	// set io-pins on PortC
 PORTC=0; 	//LCD-Datenbus

 DDRD=0xF2;  	// set io-pins on PortD
 PORTD=0x02; 	//LCD-Steuersignale siehe lcd.h

 DDRA=0; 	//Alles Eingnge
 PORTA=0xFF; 	//Eingnge mit Pullups setzen

 SFIOR&=!(1<<PUD); 	//Pullups Enable
// SFIOR=0; 	//Pullups Enable

#ifdef MMC_CARD_SPI
 MMC_IO_Init();
#endif

 ser_init();
 LCDInit();

 LCDCls();
 
 sei();              //enable interrupts

 IdentifyMedia(); //LaufwerksInformationen holen

 int i;
 unsigned long sector;

 RED_ON();
 GREEN_OFF();

 for(i=0; i<BYTE_PER_SEC; i++) dirbuf[i]=0; //fill write buffer with zeroes

 for(sector=0; sector<=maxsect; sector++) //delete the whole card
// for(sector=0; sector<=100; sector++) //for deleting MBR,FAT,Bootsector
  {
   if(sector%64==0) { LCDPos(1,1); printf("%lu\n",sector); }
    //Do not print ALL sector numbers
   WriteSector(sector,dirbuf);
  }

 GREEN_ON();
 RED_OFF();
 cli(); // Disable interrupts
 
 for(;;) // loop forever
  {
  }
}

